<template>
	<div class="board-wrapper">
		<div v-if="isSaving" class="spinner-wrapper"><spinner></spinner></div>
		<div v-else class="board-content">
			<div class="new-drawing-title"> {{title}} </div>
			<div class="canvas-container">
				<board-brush-picker v-on:pickBrush="setBrushSize"></board-brush-picker>
				<board-canvas v-on:onDrawBreak="onDrawBreak" v-on:setStartTime="setStartTime" :brushColor="brushColor" :brushSize="brushSize"></board-canvas>
				<board-color-picker v-on:pickColor="setBrushColor"></board-color-picker>
			</div>
			<div v-if="shareUrl" class="share-url">
				{{shareUrl}}
			</div>
			<div v-else class="drawing-action-buttons">
				<mdc-button @click="saveDrawingAsPublic()" :raised="true" :primary="true">Save as Public</mdc-button>
				<mdc-button @click="shareDrawingWithUrl()" :raised="true" :primary="true">Share with URL</mdc-button>
			</div>
		</div>
	</div>
</template>

<script>

import Spinner from 'vue-simple-spinner'
import { Button } from 'vue-mdc'
import BoardCanvas from './BoardCanvas'
import BoardColorPicker from './BoardColorPicker'
import BoardBrushPicker from './BoardBrushPicker'
import _ from 'lodash'
export default {
	components: {
		BoardCanvas,
		BoardColorPicker,
		BoardBrushPicker,
		ButtonMdc: Button,
		Spinner
  	},
	data () {
		return {
			titles: ['Be Creative, Be You.', 'Be Creative, Make a Change.', 'Feel it, Draw it.'],
			drawing: [],
			startTime: {},
			brushColor: '',
			brushSize: '',
			isSaving: false,
			shareUrl: ''
		}
	},

	computed: {
		 title () {
			 return _.sample(this.titles)
		 }
	},

	methods: {
		setBrushColor (colorHex) {
			this.brushColor = colorHex
		},

		setBrushSize (size) {
			this.brushSize = size
		},
		
		onDrawBreak (drawing) {
			this.drawing = drawing
		},
		
		setStartTime () {
			this.startTime = new Date()
		},
		
		saveDrawingAsPublic (isPublic) {
			this.isSaving = true
			this.doSaveDrawing(true)
				.then(response => {
					this.isSaving = false
					this.$router.push({ name: 'drawings' })
				})
				.catch(err => {
					this.isSaving = false
					console.log(err)
				})
		},

		shareDrawingWithUrl () {
			this.doSaveDrawing(false)
				.then(drawing => {
					this.shareUrl = `${location.protocol}//${location.hostname}/#/${drawing.body.drawingId}`
				})
				.catch(err => {
					console.log(err)
				})
		},

		doSaveDrawing (isPublic) {
			return this.$http.post('https://us-over-board-server.herokuapp.com/api/drawing', {
				drawingSegments: this.drawing.segments,
				dataUrl: this.drawing.dataUrl,
				creationDate: new Date(),
				drawDuration: new Date().getTime() - this.startTime,
				isPublic
			})
		}
	}
}
</script>

<style scoped>
	.board-wrapper {
		text-align: center;
	}

	.new-drawing-title {
		text-align: center;
		padding: 30px 0 25px;
		font-size: 24px;
	}
	
	.canvas-container {
		display: inline-block;
    	position: relative;
		margin-bottom: 40px;
	}

	.drawing-action-buttons button {
		margin: 0 10px;
	}

	.share-url {
		color: #a6a6a6;
	}
</style>
